
// (fragmento de explicacion en hybbuck9.cpp)
//
//           sea i un valor entre 0 y n-4
//           y sean a y b valores del dominio de la variable (0..2^n +1)
//
//           g_amp[i][a][b].valor = el coste de la variable i+2 mas el coste de la mejor 
//                                  extension de las variables 1..i+1 , cuando la variable
//                                  i+2 tiene el valor b y la variable i+3 tiene el valor a
//
//           g_amp[i][a][b].arg = el valor de la variable i+2 de la mejor extension de las
//                                variables 1..i+1 a la variable i+2, cuando la variable
//                                i+2 tiene el valor b y la variable i+3 tiene el valor a
//
//          el coste es el numero de muertas de los bits 0..n/2-1, o infinito si no hay
//          combinacion posible en que todas las celdas representadas por los bits 0..n/2-1
//          sean estables.
//          La ultima celda puede tomar cualquier valor, pero no aadimos su coste, ni
//          podemos mirar su estabilidad (por lo que en las cotas los costes solo difieren
//          en este aspecto).
// 
//
// Estas variables tienen dominio [0..2^n/2+1]x[0..2^n/2+1]
// Equivalen a las variables reales, izquierda o derecha, de dominio
// [0..2^n/2-1]x[0..2^n/2-1], pero sin estar condicionadas a la fila central.
// Estas variables de coste real (no las cotas) tienen de coste el numero de 0's 
// (o infinito si hay alguna inestabilidad) de las n/2 primeras celdas, pero no se cuenta
// ni se mira la ultima celda de la fila central)
//


void eliminar_variable_amp_1 (mejor_extension_cota g_amp)
{
// elimina la variable 1, y aade a la variable 2 el coste de la mejor extension
// de la variable 1. Este coste depende del valor de la variable 3 y el valor
// de la variable 2
// Notacion: variables 1..n -> indices 0..n-1 en fcent
//           variables 2..n-2 -> indices 0..n-4 en g_amp
	short coste_min;
	short coste;
	short a,b,c;
	short max_asig;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,mascara;
	int nf,fin_filas,ab;

	max_asig=(1<<(M+2))-1;
	mascara=(1<<M)-1;

	for (a=0;a<=max_asig;a++)
	{
		for (b=0;b<=max_asig;b++)
		{
			ab=pos[a][b];
			coste_min=255;
			if (ab>=0)
			{
				coste_ana_b=1-((b>>M)&1); // los costes ternarios de la estructura de trios
				                          // validos no tienen aadido el coste de la celda
				                          // central mas adyacente a la fila b.
				for (col=0;col<=3;col++)// Miro combinaciones validos con las 4 posibles
				{                       // combinaciones de 2 celdas centrales
					if (col==0) ini_c=0;
#if (!solo_simetrico)
					else if (col==1) ini_c=1<<M;
					else if (col==2) ini_c=1<<(M+1);
#endif
					else if (col==3) ini_c=3<<M;

					if ( !((col==3)&&((b>>M)==2)&&((a>>M)==3)) )
					{
						num_filas=t_validos[col][ab].num_filas;

						if (num_filas>0)
						{
							coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
							nf = t_validos[col][ab].apunt;
							fin_filas = nf+num_filas;
							do
							{
								c=filas[nf]+ini_c;
								coste = coste_ter + costeB1[c][b] + costeU[c];
								nf++;
								if (coste<coste_min)
								{
									coste_min=coste;
								}
							}
							while (nf<fin_filas);
						}
					}
				}
				g_amp[0][ab]=(unsigned char)coste_min;
			}
		}
	}
}


void eliminar_variable_amp (short i, mejor_extension_cota g_amp)
{
// Pre: eliminadas variables 1..i-1
// elimina la variable i, y aade a la variable i+1 el coste de la mejor extension
// de las variables 1..i. Este coste depende del valor de la variable i+2 y el valor
// de la variable i+1
// Notacion: variables 1..n -> indices 0..n-1 en fcent
//           variables 2..n-2 -> indices 0..n-4 en g_amp
	short coste_min;
	short coste;
	short a,b,c;
	short max_asig;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,mascara;
	int nf,fin_filas,ab,bc;

	max_asig=(1<<(M+2))-1;
	mascara=(1<<M)-1;

	for (a=0;a<=max_asig;a++)
	{
		for (b=0;b<=max_asig;b++)
		{
			ab=pos[a][b];
			coste_min=255;
			if (ab>=0)
			{
				coste_ana_b=1-((b>>M)&1); //los costes ternarios de la estructura de trios
				                          //validos no tienen aadido el coste de la celda
				                          //central mas adyacente a la fila b
				for (col=0;col<=3;col++)// Miro combinaciones validos con las 4 posibles
				{                       // combinaciones de 2 celdas centrales
					if (col==0) ini_c=0;
#if (!solo_simetrico)
					else if (col==1) ini_c=1<<M;
					else if (col==2) ini_c=1<<(M+1);
#endif
					else if (col==3) ini_c=3<<M;

					if ( !((col==3)&&((b>>M)==2)&&((a>>M)==3)) )
					{
						num_filas=t_validos[col][ab].num_filas;

						if (num_filas>0)
						{
							coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
							nf = t_validos[col][ab].apunt;
							fin_filas = nf+num_filas;
							do
							{
								c=filas[nf]+ini_c;
								bc=pos[b][c];
								nf++;
								if (bc>=0)
								{
									coste=coste_ter+g_amp[i-2][bc];
									if (coste<coste_min)
									{
										coste_min=coste;
									}
								}
							}
							while (nf<fin_filas);
						}
					}
				}
				g_amp[i-1][ab]=(unsigned char)coste_min;
			}
		}
	}
}


void calcular_cotas (mejor_extension_cota g_amp)
{
	short i;

	eliminar_variable_amp_1 (g_amp);
	for (i=2;i<=N-3;i++)
	{
		eliminar_variable_amp (i,g_amp);
	}
}
