
#if (M<3)
#define maxi 3
#else
#define maxi M
#endif


void calcular_validaciones_3x3 (bool val[8][8][8])
{
	short i,j,k,a,b,c,ady;
	short bit[8][3];
	short vivas[8];
	bool ok;

//  | | | |
//  |a|b|c|
//  | | | |

// a,b,c: valores de 000 (0) hasta 111 (7). Representan una columna de 3 celdas

	for (i=0;i<=7;i++)
	{
		k=0;
		for (j=0;j<=2;j++)
		{
			if ((i&(1<<j))==0)
			{
				bit[i][j]=0;
			}
			else
			{
				bit[i][j]=1;
				k++;
			}
		}
		vivas[i]=k;
	}
// Calculo vector bool val[8][8][8]: 
// val[a][b][c] = falso, si esas 3x3 celdas no son estables
//              = cierto, si si pueden llegar a serlo: es decir, la celda central cumple
//                        las reglas del juego de la vida, y las celdas laterales centrales
//                        estan muertas o bien vivas adyacentes a menos de 4 vivas
	i=0;
	j=0;
	for (a=0;a<=7;a++)
		for (b=0;b<=7;b++)
			for (c=0;c<=7;c++)
			{
				ok=true;
				if (bit[b][1]==0) // bit central
				{
					ady=vivas[a]+vivas[b]+vivas[c];
					if (ady==3) ok=false;
				}
				else
				{
					ady=vivas[a]+vivas[b]+vivas[c]-1; // la central de b no cuenta
					if ((ady<2)||(ady>3)) ok=false;
				}
				if ((ok)&&(bit[a][1]>0))
				{
					ady=vivas[a]+vivas[b]-1;
					if (ady>3) ok=false;
				}
				if ((ok)&&(bit[b][0]>0))
				{
					ady=bit[a][0]+bit[a][1]+bit[b][1]+bit[c][1]+bit[c][0];
					if (ady>3) ok=false;
				}
				if ((ok)&&(bit[b][2]>0))
				{
					ady=bit[a][2]+bit[a][1]+bit[b][1]+bit[c][1]+bit[c][2];
					if (ady>3) ok=false;
				}
				if ((ok)&&(bit[c][1]>0))
				{
					ady=vivas[b]+vivas[c]-1;
					if (ady>3) ok=false;
				}
				val[a][b][c] = ok; 
			}
}


// INICIALIZAR COLUMNAS VALIDAS

//                  Esta columna: { |O O O| no es valida a pesar de cumplir las reglas.
//                                { |OO OO|
// Podemos mirar estas establidades:| xxx |, y no existe combinacion posible de estabilidad
//

bool combinaciones_por_arriba (short k, short i, short lim, int col, short a, short b, bool val[8][8][8])
{
// col -> numero en base 4
//
// -| |-| |a|b|c| |+
//  | |+| | | | | |   lim=0 => adyacente por la izq. a todo 0's (tb miramos estab cuando i=1)
// 0 1 2 3 4 5 6 7    lim=1 => no hay esa restriccion
//           i
//                   Primera llamada: i=0, a=0
//
	bool ok;
	short c;

	if (i==k) return true;
	else
	{
		ok=false;
		c=(col>>(i+i))&3;
		if ((i<=lim)||(val[a][b][c])) ok=combinaciones_por_arriba (k,i+1,lim,col,b,c,val);
		if (!ok)
		{
			if ((i<=lim)||(val[a][b][c+4])) ok=combinaciones_por_arriba (k,i+1,lim,col,b,c+4,val);
		}

		return ok;
	}
}


bool combinaciones_por_abajo (short k, short i, short lim, int col, short a, short b, bool val[8][8][8])
{
	bool ok;
	short c;

	if (i==k) return true;
	else
	{
		ok=false;
		c=((col>>(i+i))&3)<<1;
		if ((i<=lim)||(val[a][b][c])) ok=combinaciones_por_abajo (k,i+1,lim,col,b,c,val);
		if (!ok)
		{
			if ((i<=lim)||(val[a][b][c+1])) ok=combinaciones_por_abajo (k,i+1,lim,col,b,c+1,val);
		}

		return ok;
	}
}


void cols_validas_de_2x7 (short i, short col, short a, short b, bool val[8][8][8], bool validas[1<<14])
{
	short vivas2x3,desp;
	bool ok;

	if (i==7)
	{
		ok=combinaciones_por_arriba (7,0,1,col,0,0,val);
		if (ok) ok=combinaciones_por_abajo (7,0,1,col,0,0,val);
		if (ok) validas[col]=true;
	}
	else
	{
		vivas2x3=((a+1)>>1)+((b+1)>>1);
		cols_validas_de_2x7 (i+1,col,b,0,val,validas);
		if (vivas2x3<4)
		{
			desp=12-(i+i);
			cols_validas_de_2x7 (i+1,col+(1<<desp),b,1,val,validas);
			cols_validas_de_2x7 (i+1,col+(2<<desp),b,2,val,validas);
			if (vivas2x3<3)
			{
				cols_validas_de_2x7 (i+1,col+(3<<desp),b,3,val,validas);
			}
		}
	}
}


void encontrar_cols_validas_de_2x7 (bool validas[1<<14])
{
	bool val[8][8][8];
	short j;

	for (j=0;j<=16383;j++) validas[j]=false;
	calcular_validaciones_3x3 (val);
	cols_validas_de_2x7 (0,0,0,0,val,validas);
}


void cols_validas_de_2xK (int *num_par, bool val[8][8][8], int pos[1<<(M+2)][1<<(M+2)])
{
	bool ok;
	int col;
	short a,b,k,max_asig;

	k=M+2;
	max_asig=(1<<k)-1;
	for (a=0;a<=max_asig;a++)
		for (b=0;b<=max_asig;b++)
		{
			pos[a][b]=-1;
			col=juntar(b,a,k);
			ok=combinaciones_por_arriba (k,0,0,col,0,0,val);
			if (ok) ok=combinaciones_por_abajo (k,0,0,col,0,0,val);
			if (ok)
			{
				pos[a][b]=*num_par;
				(*num_par)++;
			}
			else pos[a][b]=-1;
		}
}


int ini_pares_validos (int pos[1<<(M+2)][1<<(M+2)]) // de tamao M+2
{
	int num_par;
	bool val[8][8][8];

	calcular_validaciones_3x3 (val);
	num_par=0;
	cols_validas_de_2xK (&num_par,val,pos);

	return num_par;
}


// INICIALIZAR TRIOS DE FILAS VALIDOS 


void ini_vivas (short vivas[1<<maxi], short celdasfila)
{
	short max_asig;
	short i,j,k;

	max_asig=(1<<celdasfila)-1;

	for (i=0;i<=max_asig;i++)
	{
		j=i;
		k=0;
		while (j>0)
		{
			k=k+(j&1);
			j=j>>1;
		}
		vivas[i]=k;
	}
}


void buscar_3as_filas (short i, int col, short a, short b, short filamedio, smallint fila, short ini_fila, int *num, bool val[8][8][8])
{
	// | | | | | |-| | }
	// |a|b|c| | | | | } col
	// | | | | | |+| |
	//      i      (0)
	short c;

	if (i==-1)
	{
		if ((val[a][b][0])&&(val[b][0][0])&&(pos[filamedio][fila+ini_fila]>=0))
		{
			filas[*num]=fila;
			(*num)++;
		}
	}
	else
	{
		c=(col>>(i+i))&3;
		if (val[a][b][c]) 
		{
			buscar_3as_filas (i-1,col,b,c,filamedio,fila,ini_fila,num,val);
		}
		if (val[a][b][c+4])
		{
			buscar_3as_filas (i-1,col,b,c+4,filamedio,fila+(1<<i),ini_fila,num,val);
		}
	}
}


void buscar_trios_validos (short c, int *num_t, trios validos, short vivas[1<<maxi], bool val[8][8][8])
{
	//      | | | |-| | | | -> a (ancho m+2)
	// col: |+| | | | | |-| -> b (ancho m+2)
	//      | c | |+| | | | -> info de filas validas, ancho m
	int col,num,ab;
	short a,b,d,e;
	short max_asig,mascara;

	max_asig=(1<<(M+2))-1;
	mascara=(1<<M)-1;
	num=*num_t;
	for (a=0;a<=max_asig;a++)
		for (b=0;b<=max_asig;b++)
		{
			ab=pos[a][b];
			if (ab>=0)
			{
				col=juntar(b,a,M+2);
				d=((col>>(M+M+2))&3)+((c&2)<<1);
				e=((col>>(M+M))&3)+((c&1)<<2);

				buscar_3as_filas (M-1,col,d,e,b,0,c<<M,&num,val); // de bit+ a bit- (->)

				validos[c][ab].num_filas=num-*num_t;
				if (num-(*num_t)>0) 
				{
					validos[c][ab].coste_ter=M-vivas[b&mascara];
					validos[c][ab].apunt=*num_t;
					*num_t=num;
				}
			}
		}
}


int calcular_trios_validos (trios validos)
{
	bool val[8][8][8];
	short c;
	short vivas[1<<maxi];
	int num_t;
	int max_asig;

	calcular_validaciones_3x3 (val);
	max_asig=(1<<(2*M+3))-1;
	num_t=0;
	if (M<3) ini_vivas(vivas,3);
	else ini_vivas(vivas,M);

	for (c=0;c<=3;c++)
	{
		buscar_trios_validos (c,&num_t,validos,vivas,val);
	}

	return num_t;
}


void ini_costes (costes_binarios costeB1, costes_unarios costeU)
{
	short i,j,max_asig;

	max_asig=(1<<(M+2))-1;
	for (i=0;i<=max_asig;i++)
	{
		for (j=0;j<=max_asig;j++)
		{
			costeB1[i][j]=coste_binario_1 (i,j,false,false);
		}
		costeU[i]=coste_unario (i);
	}
}


void ini_costes_para_cotas (costes_binarios costeB1, costes_unarios costeU)
{
	short i,j,max_asig;

	max_asig=(1<<(M+2))-1;
	for (i=0;i<=max_asig;i++)
	{
		for (j=0;j<=max_asig;j++)
		{
			costeB1[i][j]=coste_binario_1 (i,j,false,true);
		}
		costeU[i]=coste_unario (i);
	}
}


void ini_costes_para_sim (costes_binarios costeB1, costes_unarios costeU, mejor_extension_cota g_amp)
{
	short i,j,ii,jj,max_asig;

	max_asig=(1<<(M+1))-1;
	for (i=0;i<=max_asig;i++)
	{
		ii=((i&(1<<M))<<1)+i;
		for (j=0;j<=max_asig;j++)
		{
			jj=((j&(1<<M))<<1)+j;
			costeB1[ii][jj]=coste_binario_1 (ii,jj,true,false);
		}
		costeU[ii]=coste_unario (ii);
	}
}
