

void mantener_info_minimo (short coste_min, bool definitivo)
{
	if (!definitivo) printf ("current optimal cost: ");
	printf ("%d  (%d living cells) \n",coste_min,N*N-coste_min);
}


void info_mem ()
{
	int coste1a,coste1b,coste2,coste3,coste4,coste5;
	short mem_t;

	coste1a=sizeof(trios);
	coste1b=totalfilas*sizeof(smallint);
	coste2=sizeof(costes_binarios)+sizeof(costes_unarios);
	coste3=2*sizeof(mejor_extension_coste)+sizeof(mejor_extension_fila)+sizeof(nuevos_costes_binarios);
	coste4=sizeof(mejor_extension_cota);
	coste5=sizeof(posicionador);
	if (solo_simetrico) coste3=0;
	mem_t=Mb(coste1a+coste1b+coste2+coste3+coste4+coste5); // en megabytes
	printf ("%d Mb reserved\n",mem_t);
}


void presentacion()
{
	printf ("===============================================================================\n");
	printf ("               GAME OF LIFE. MAXIMUM STILL-LIFE IN BOARD OF NxN.               \n");
	printf ("===============================================================================\n");

	printf ("\nN=%d\n",N);
	info_mem ();

	printf ("\nInitializating ...\n");

}


void info_porcent_trabajo (int col1, int col2) // izquierda,derecha
{
	unsigned char s[N+2];
	bool v1,v2;
	short i;

	s[0]=13; // inicio de linea
	for (i=N-1;i>=0;i--)
	{
		v1=(col1&(1<<i))!=0;
		v2=(col2&(1<<i))!=0;
		if ((v1)&&(v2)) s[N-i]=219;
		if ((v1)&&(!v2)) s[N-i]=223;
		if ((!v1)&&(v2)) s[N-i]=220;
		if ((!v1)&&(!v2)) s[N-i]=32;
	}
	s[N+1]=0;
	printf ("%s",s);
}


void mostrar_solucion (int sol[N], short coste_min, tiempo t, int elims, int elim[N+1])
{
	short i,j,num_vivas;
	#if (pausa_al_acabar==1)
	char s[4];
	#endif

	num_vivas=0;
	printf ("\n");

	for (j=0;j<N;j++)
	{
		if (bit(sol[0],j)==1) 
		{
			printf ("O");
			num_vivas++;
		}
		else printf (" ");
	}
	/*
	for (j=0;j<10;j++) printf (" ");
	printf ("%d eliminaciones de variable",elims);
	*/
	printf ("\n");
	for (j=0;j<N;j++)
	{
		if (bit(sol[1],j)==1) 
		{
			printf ("O");
			num_vivas++;
		}
		else printf (" ");
	}
	printf ("\n");

	for (i=2;i<N;i++)
	{
		for (j=0;j<N;j++)
		{
			if (bit(sol[i],j)==1) 
			{
				printf ("O");
				num_vivas++;
			}
			else printf (" ");
		}
		/*
		for (j=0;j<10;j++) printf (" ");
		printf ("variable %d:  %d",i+1,elim[i+1]);
		*/
		printf ("\n");
	}
	
	printf ("\nN=%d",N);
	for (j=0;j<21;j++) printf (" ");

	if (num_vivas+coste_min!=N*N) printf ("Error: vivas+coste difiere de n*n");
	else if (!reja_estable(sol)) printf ("Error: la reja no es estable");

	printf ("\n");
	printf ("%d living cells",N*N-coste_min);
	for (j=0;j<10;j++) printf (" ");

	if (t.dias>0)
	{
		printf ("%d day",t.dias);
		if (t.dias==1) printf (" ");
		else printf ("s ");
	}
	if (t.horas>0)
	{
		printf ("%d hour",t.horas);
		if (t.horas==1) printf (" ");
		else printf ("s ");
	}
	if (t.min>0)
	{
		printf ("%d minut",t.min);
		if (t.min==1) printf (" ");
		else printf ("s ");
	}
	printf ("%d second",t.seg);
	if (t.seg==1) printf (" ");
	else printf ("s ");

	#if (pausa_al_acabar==1)
	scanf ("%s",s);
	#endif
}
